<template>
<div>Resultats:
<div class="card" v-for="contrat in resultats" v-bind:key="contrat.detailsContrat.noGestionInterne">
<div class="container">
<h4><b><a @click="openModal(contrat.detailsContrat.noGestionInterne,contrat.employeur.siret)">{{ contrat.detailsContrat.noGestionInterne }}</a></b></h4> 

<p>{{ contrat.alternant.nom }} {{ contrat.alternant.prenom }} {{ contrat.alternant.dateNaissance }} </p>
<p>{{ contrat.employeur.siret }}</p>
<p>du {{ contrat.detailsContrat.dateDebutContrat }} au {{ contrat.detailsContrat.dateConclusion }}</p>
<p @click="showHistory(contrat.detailsContrat.noGestionInterne, contrat.employeur.siret)">
 <span class="button">
  <span v-if="selectedContrat==0||selectedContrat!==contrat.detailsContrat.noGestionInterne">Voir</span><span v-if="selectedContrat==contrat.detailsContrat.noGestionInterne">Cacher</span>
   la suite des contrats
   </span>
   </p>

<div v-if="selectedContrat==contrat.detailsContrat.noGestionInterne">
  <h3>Historique :</h3>
  <div v-for="(item, index) in history" :key="index">
  <span v-if="index==0">
  <h4>Contrat précédent :</h4>
  </span>
  <span v-if="index==1">
  <h4>Contrat suivant :</h4>
  </span>
      siret employeur: {{ item.employeur.siret }}<br>
      Date de naissance alternant: {{ item.alternant.dateNaissance }}<br>
      Nom alternant: {{ item.alternant.nom }} {{ item.alternant.prenom }}<br>
      DateConclusionContrat: {{ item.detailsContrat.dateConclusion }}<br>
      Date debut contrat": {{ item.detailsContrat.dateDebutContrat}}<br>
      no gestion interne": <a href="" alt="Accéder au contrat">{{ item.detailsContrat.noGestionInterne }}</a>
  </div>
</div>
</div>
</div>
<br><br><br><br>
</div> 
<ContratModal v-model:contrat="contrat" v-model:show="show" @closemodal="closeModal"/>
 
</template>

<script>
import { ref } from "vue";
import contratsService from "@/services/contratsService.js";
import ContratModal from "@/components/ContratModal.vue";


export default {
  name: "Result",
  props: {
    resultats: Array,
  },
    components: {
    ContratModal
  },
  setup() {
    const contrat = ref({});
    const show = ref(false);
    const history = ref([]);
    const selectedContrat = ref(0);


    async function showHistory(numContrat, siret) {
      if (selectedContrat.value != numContrat) {
        history.value = await contratsService.getHistory(numContrat, siret);
        selectedContrat.value = numContrat;
      } else {
        history.value = [];
        selectedContrat.value = 0;
      }
    }
    async function openModal(numContrat, siret) {
      
      contrat.value = await contratsService.getContrat(numContrat, siret, 0);
      show.value = true;
    }
    function closeModal() {
      show.value = false;
    }
    return { showHistory, openModal, closeModal, history, selectedContrat,  show, contrat };
  },
};
</script>

<style scoped>
.card {
  box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2);
  transition: 0.3s;
  width: 40%;
  margin: auto;
  margin-bottom: 5px;
  background-color: rgba(256, 256, 256, 0.5);
}

.card:hover {
  box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.2);
}

.container {
  padding: 2px 16px;
}

.button {
  background-color: rgba(252, 252, 252, 0.5);
  color: black;
  border: 2px solid #4caf50; /* Green */
  padding: 2px;
  border-radius: 5px;
}
</style>
